

import java.io.*;

/*
 * In Java gibt es die seek-Funktion in der RandomAccess-Klasse
 */

class HexFile {
  private String _sFilename="";
  private long  _filesize = 0;

  public HexFile(String sFilename) {
      this._sFilename =sFilename;
  }

  public void loadFile(String sFilename) {
    this._sFilename =sFilename;
    File file = new File(sFilename);
    _filesize = file.length();
    System.out.println(_filesize);
  }

  public byte[] loadRow(int offset, int count) {
    byte [] feld = new byte[count];    
    try {       
       RandomAccessFile fin =  new RandomAccessFile(_sFilename, "r");
       if (offset>0) fin.seek(offset);
       
       int anz = fin.read(feld, 0, count);
       fin.close();
       if (anz!=feld.length) {  // letzter Rest oder EOF
         if (anz==-1) {            
            return null;
         }
         else {
             // wenn man am Ende zu wenig Bytes gelesen hat, muss ein neues Feld her
           byte [] feld2 = new byte[anz];
           for (int i=0; i<anz; i++) {
             feld2[i] = feld[i];
           }
           return feld2;
        }
       }
       else {
         return feld;
       }
    }
    catch (IOException ee) {
           System.err.println("IOException: " + ee);          
    }
    return null;
   }
  
    public String getFilename() {
        return _sFilename;
    }
    public long getFilesize() {
        return _filesize;
    }

} // HexFile
