﻿
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class SelectView  extends JFrame implements ActionListener {
    final int FONTSIZE = 14;
    
    
 
  private JMenuBar menuBar1;  // MenueContainer
  private JMenu mainFile;       
  private JMenuItem mnClose;  

  private JMenu mainRun;     
  private JMenuItem mnSearch;     
  private JMenuItem mnSearchThread;     
  private JLabel _statusbar;
    
    IInsertFile _parent; 
    
    JTextField _startverz = new JTextField();
    JComboBox _masken = new JComboBox();
    
    DefaultListModel _fileListModel = new DefaultListModel();
     JList _filelist = new JList( _fileListModel );
     
     JTextArea _editorTop = new JTextArea();
     
     CardLayout _cardLayout = new CardLayout(10,10);
     JPanel _panelCardLayout = new JPanel();
     
     JTextArea _previewEditor = new JTextArea();
     JLabel  _previewPictFile = new JLabel ();
     
     String _selectFile="";
     String [] _sMaskenArray;
    
    public SelectView (IInsertFile parent) {
        _parent = parent;  
        setSize(650,500);
        setLocation(150,150);
        setTitle("Suchen und Auswahl von Dateien");
        setGUI();
        setMenus();
    }
    
    private void setGUI() {
       setLayout( new GridBagLayout() );
       
       _filelist.setSelectionMode( ListSelectionModel.SINGLE_SELECTION);

       
        _masken.addItem("*.*");
        _masken.addItem("*.jpg;*.jpeg;*.bmp;*.png;*.gif;*.tif;*.emf;*.wmf");
        _masken.addItem("*.jpg;*.jpeg");
        _masken.addItem("*.bmp");
        _masken.addItem("*.png");
        _masken.addItem("*.tif");
        _masken.addItem("*.gif");
        _masken.addItem("*.exe");
        _masken.addItem("*.txt;.dat");
        _masken.addItem("*.cs");
        _masken.addItem("*.java");
        _masken.addItem("*.html;*.xhtml;*.css;*.php");
        _masken.addItem("*.dbf;*.mdb");
        _masken.setSelectedIndex(0);
        _masken.setEditable(true);
       
       JLabel lstartverz = new JLabel("Startverzeichnis");
       JLabel lmaske = new JLabel("Dateimaske");
       add( lstartverz,
               new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0
               ,GridBagConstraints.WEST, GridBagConstraints.NONE,
             new Insets(10,0,20,20), 0, 0));
       add( _startverz,
               new GridBagConstraints( 1, 0, 1, 1, 100.0, 0.0
               ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
             new Insets(10,0,20,20), 0, 0));
        
       add( lmaske,
               new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0
               ,GridBagConstraints.WEST, GridBagConstraints.NONE,
             new Insets(0,0,20,20), 0, 0));
       add( _masken,
               new GridBagConstraints( 1, 1, 1, 1, 100.0, 0.0
               ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
             new Insets(0,0,20,20), 0, 0));

       
    lstartverz.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );
    lmaske.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );
    _startverz.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );
    _masken.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );
    _filelist.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );
    _editorTop.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );
    _previewEditor.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );
     
        
       _startverz.setText ( (String) System.getProperties().get("user.dir")  );
           
     _panelCardLayout.setLayout(_cardLayout);

  // Splitter  links=Baum   rechts=tabelle
    JSplitPane vertsplit = new JSplitPane(JSplitPane.VERTICAL_SPLIT,false,     
            new JScrollPane( new JScrollPane(_editorTop)), _panelCardLayout );
    vertsplit.setDividerLocation(200);
    JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,false,     
    new JScrollPane(_filelist), vertsplit );
    
    _panelCardLayout.add("editor", new JScrollPane(_previewEditor));
    _panelCardLayout.add("bild", new  JScrollPane(_previewPictFile) );
    split.setDividerLocation(150);
       
       add( split,
               new GridBagConstraints( 0, 2, 2, 1, 100.0, 100.0
               ,GridBagConstraints.WEST, GridBagConstraints.BOTH,
             new Insets(0,0,20,20), 0, 0));
     
       
     _statusbar = new JLabel();       
     add( _statusbar,
               new GridBagConstraints( 0, 3, 2, 1, 100.0, 0.0
               ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
             new Insets(0,0,20,20), 0, 0));
      _statusbar.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );      
      _statusbar.setForeground(Color.RED);
       
   _filelist.addListSelectionListener(
           new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent e) {           
                    FileListClick(e);                    
                }
           }
    );
   
    _filelist.addMouseListener(new java.awt.event.MouseAdapter() {
          public void mouseClicked(MouseEvent e) {
          FileListMouseClick(e);
        }
       });   
       
    }  // setGUI
    
    
  private void setMenus() {
    menuBar1 = new JMenuBar();

      // DATEI
    mainFile = new JMenu("Datei");
    mnClose = new JMenuItem("Schließen");
    mnClose.addActionListener( this );
    mainFile.add(mnClose);

      // Hauptmenue FILE in den MenueBar einfÃ¼gen
    menuBar1.add(mainFile);

    mainRun = new  JMenu("Starten");
    mnSearch = new JMenuItem("Suchen der Dateien");
    mnSearch.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F5, 0));
    
    mnSearchThread = new JMenuItem("Suchen der Dateien (Thread)");
    mnSearchThread.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F5, KeyEvent.CTRL_MASK));

    mainRun.add(mnSearch);
    mainRun.add(mnSearchThread);
    menuBar1.add(mainRun);
    mnSearch.addActionListener( this );
    mnSearchThread.addActionListener( this );
    
    
    this.setJMenuBar(menuBar1);
    
    for (int i=0; i<menuBar1.getMenuCount(); i++) {
      JMenu main = menuBar1.getMenu(i);
      main.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );      
      JMenuItem mn;
      for (int j=0; j<main.getItemCount(); j++) {
        mn = main.getItem(j);
        // Abfrage auf Separator, sonst Absturz
        if ( mn instanceof JMenuItem )
          mn.setFont( new Font("Arial", Font.BOLD,FONTSIZE)  );
      }
    }
    
  } // setMenus
  
  // http://docs.oracle.com/javase/tutorial/essential/environment/sysprop.html
  
  
    public void actionPerformed(ActionEvent e) {
         JMenuItem mn = (JMenuItem) e.getSource();
         if (mn.equals(mnClose)) {
            this.dispose();
            return;
         }
         if (mn.equals(mnSearch)) {
             SearchFiles(false);
         }
         if (mn.equals(mnSearchThread)) {
             SearchFiles(true);
         }
    }    
    
    private void SearchFiles(boolean bWithThread) {
        String sStartPath = this._startverz.getText().trim();
        if ( sStartPath.equals("") ) {
            Basis.Error("Startverzeichnis", "Der Eintrag im Startverzeichnis ist leer");
        }
        if ( ! Basis.DirExists(sStartPath)  ) {
            Basis.Error("Startverzeichnis", "Der Eintrag im Startverzeichnis ist leer");
        }
        String sMasken = (String) _masken.getSelectedItem();
        _sMaskenArray = sMasken.split(";");                
        if ( sMasken.equals("") ) {
            Basis.Error("Dateimasken", "Der Eintrag im Masken ist leer");
        }
              
        //_fileListModel = new DefaultListModel();
        _fileListModel.clear();
        _filelist.setModel(_fileListModel);
        _selectFile="";
        if (bWithThread) 
            searchForFilesThread(sStartPath);
        else
            searchForFiles(sStartPath);
        
        _statusbar.setText("Anzahl der Einträge: "+_fileListModel.getSize());
        _statusbar.updateUI();
        
    }
    
    
    private void searchForFiles(String sPath) {
        File dir = new File( sPath );
        _statusbar.setText(sPath);
        _statusbar.updateUI();
        File[] items =  dir.listFiles(); // ohne Maske FilenameFiler  FileFilter);
        for (int i=0; i<items.length; i++) {
               if ( items[i].isFile() ) { 
                   String sExt = Basis.getFileExt( items[i].getName() ).toUpperCase();
                   if (_sMaskenArray.length==1  && _sMaskenArray[0].equals("*.*")) {
                       //_fileListModel.add(  _fileListModel.getSize(), new myFile(items[i].getAbsolutePath()) );
                       _fileListModel.add(  _fileListModel.getSize(), new myFile(items[i]) );
                       //_filelist.setModel(_fileListModel);
                       //System.out.println(items[i].getAbsolutePath());
                   }
                   else {
                    for (String sMaske : _sMaskenArray) {  
                        String sMaskeExt = Basis.getFileExt( sMaske ).toUpperCase();
                        if (sMaskeExt.equals(sExt))  {
                            _fileListModel.add(  _fileListModel.getSize(), new myFile(items[i]) );
                            break;
                        }
                    }
                   }
               }
            }
        for (int i=0; i<items.length; i++) {
               if ( items[i].isDirectory() ) {          
                  searchForFiles(  items[i].getPath()  );
               }
            }
    }  // searchForFiles
    
    
    private void searchForFilesThread(String sPath) {
        ThreadSearch thread = new ThreadSearch(sPath);
        thread.start();
        try {
            thread.join();
        } catch (InterruptedException ex) {
            Logger.getLogger(SelectView.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    class ThreadSearch extends Thread {
        String _sPath="";
        public ThreadSearch(String sPath) {
            _sPath=sPath;
        }
        
        @Override
        public void run() {
            searchForFilesThread(_sPath);
        }
        
        private void searchForFilesThread(String sPath) {
            File dir = new File( sPath );
            _statusbar.setText(sPath);
            _statusbar.updateUI();
            File[] items =  dir.listFiles(); // ohne Maske FilenameFiler  FileFilter);
            for (int i=0; i<items.length; i++) {
                if ( items[i].isFile() ) { 
                    String sExt = Basis.getFileExt( items[i].getName() ).toUpperCase();
                    if (_sMaskenArray.length==1  && _sMaskenArray[0].equals("*.*")) {
                        _fileListModel.add(  _fileListModel.getSize(), new myFile(items[i]) );
                    }
                    else {
                        for (String sMaske : _sMaskenArray) {  
                            String sMaskeExt = Basis.getFileExt( sMaske ).toUpperCase();
                            if (sMaskeExt.equals(sExt))  {
                                _fileListModel.add(  _fileListModel.getSize(), new myFile(items[i]) );
                                //_filelist.updateUI();
                                //_filelist = new JList( _fileListModel  );
                                break;
                            }
                        }
                    }
                }
                }
            for (int i=0; i<items.length; i++) {
                if ( items[i].isDirectory() ) {          
                    searchForFiles(  items[i].getPath()  );
                }
            } // for
        }
       
   }
   
   private void FileListClick(ListSelectionEvent e) {
       if ( _filelist.getSelectedIndex()>=0) {
        myFile item = (myFile) _filelist.getSelectedValue();  //           e.getFirstIndex();
        if ( _selectFile != item.getAbsolutePath() ) {
            System.out.println("item: "+item);  // _selectFile
            String sItem="Verzeichnis:" +System.getProperty("line.separator");
            sItem+= item.getPath()+System.getProperty("line.separator");
            sItem+="Dateiname:";
            sItem+= item.getName()+System.getProperty("line.separator")+System.getProperty("line.separator");        

            sItem+= "Größe: "+item.length()+" Bytes"+System.getProperty("line.separator");
            _editorTop.setText(sItem);
            
            // Eintragen in die beiden Preview
            String sExt = Basis.getFileExt( item.getName() ).toUpperCase();
            if ( sExt.equals(".TXT") || sExt.equals(".DAT") || sExt.equals(".INI") || sExt.equals(".HTML")
                 || sExt.equals(".XHTML") ||  sExt.equals(".XML") || sExt.equals(".CSS")  || sExt.equals(".CSV") 
                 || sExt.equals(".PHP")  || sExt.equals(".JAVA") || sExt.equals(".CS")  ) {
                _cardLayout.show(_panelCardLayout,"editor");
                String sValue="";
                FileInputStream fin;
                InputStreamReader iin;
                LineNumberReader din;                
                try {
                    fin = new FileInputStream( item.getAbsolutePath() );
                    iin = new InputStreamReader(fin);
                    din = new LineNumberReader(iin);                    
                    while  ( din.ready()  ) {
                        sValue  += din.readLine()+System.getProperty("line.separator");                         
                    }                    
                }
                catch (IOException e2) {
                    System.err.println("IOException: " + e);
                }
                _previewEditor.setText(sValue);
                _previewEditor.setCaretPosition(0);  // Cursor steht am Anfang
            }
            else {                
                // Bitmap wird nicht standardmaessig unterstuetzt
                if (sExt.equals(".JPG") || sExt.equals(".JPEG") ||  sExt.equals(".PNG") ||  sExt.equals(".GIF")   ) {
                    _cardLayout.show(_panelCardLayout,"bild");
                    _previewPictFile.setIcon( loadIcon(item.getAbsolutePath(), item.getName() ) );
                }
                else {
                    _previewEditor.setText("Keine Anzeige");
                    _cardLayout.show(_panelCardLayout,"editor");
                }
            }
            _selectFile=item.getAbsolutePath();
        }
       }
   }
   
   private ImageIcon loadIcon(String name, String description) {
   	// String path = "images" + name;
   	String path = name;  // Hier eventuell den path eintragen
      return new ImageIcon(path, description);
  }



   private void FileListMouseClick(MouseEvent e) {
       if (e.getClickCount()==2) {
          myFile item = (myFile) _filelist.getSelectedValue();  //           e.getFirstIndex();
          _parent.insertFile( item.getAbsolutePath() );
           
       }
       
   }
   
   class myFile /*extends File*/ {
       File _item; 
       public myFile(File item) {
           _item = item;
       }
       
       //@Override
       public String toString() {
           //System.out.println(_item.getName());
         return _item.getName();  
       }
       
       public String getName() {
           return _item.getName();  
       }
       
       public String getAbsolutePath() {
           return _item.getAbsolutePath();  
       }
       
       public String getPath() {
           return _item.getPath();
       }
       
       public long length() {
           return _item.length();
       }
       
   }
   
   
    
}


/*
 * 
 public class ImageFileFilter implements FileFilter
{
  private final String[] okFileExtensions = 
    new String[] {"jpg", "png", "gif"};

  public boolean accept(File file)
  {
    for (String extension : okFileExtensions)
    {
      if (file.getName().toLowerCase().endsWith(extension))
      {
        return true;
      }
    }
    return false;
  }
}


import java.util.*;

public class FileFilterTest
{
  public static void main(String[] args)
  {
    new FileFilterTest();
  }

  public FileFilterTest()
  {
    File dir = new File("/Users/al");

    // list the files using our FileFilter
    File[] files = dir.listFiles(new ImageFileFilter());
    for (File f : files)
    {
      System.out.println("file: " + f.getName());
    }
  }
}* 
 * 
 */